﻿//------------------------------------------------------------------------------
#pragma hdrstop
#include "Form_MsgEdit.h"
//------------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AdvPanel"
#pragma link "AdvToolBar"
#pragma link "AdvToolBarStylers"
#pragma link "AdvOfficeComboBox"
#pragma link "AdvOfficeSelectors"
#pragma link "HTMLabel"
#pragma link "AdvMemo"
#pragma link "AdvOfficePager"
#pragma link "AdvOfficePagerStylers"
#pragma link "AdvmWS"
#pragma link "AdvOfficeStatusBar"
#pragma link "AdvGlowButton"
#pragma link "AdvOfficeComboBox"
#pragma link "AdvOfficePager"
#pragma link "AdvOfficeSelectors"
#pragma link "AdvToolBar"
#pragma resource "*.dfm"
//------------------------------------------------------------------------------

__fastcall TFormMsgEdit::TFormMsgEdit(TComponent* Owner) : TForm(Owner)
{
Top		= 10;
Left	= 10;
Height	= 500;
Width	= 730;              // UNFREEZE method 1 - change to larger value e.g. 830, with this value it will be frozen

// RefreshToolBar

TControl* const BtnObj[] = { AOFNS_FmtFontName,         // 1
							 AOFSS_FmtFontSize,         // 2
							 AGB_FmtClearFormatting,    // 3
							 AGB_FmtBold,
							 AGB_FmtItalic,
							 AGB_FmtUnderline,
							 AOCS_FmtTxtColorFg,
							 AOCS_FmtTxtColorBg,
							 AGB_FmtStrikethrough,
							 AGB_FmtSubscript,
							 AGB_FmtSuperscript,
							 AGB_FmtNumbers,
							 AGB_FmtBullets,
							 AGB_FmtIndentDecr,
							 AGB_FmtIndentIncr,
							 AGB_FmtAlignLeft,
							 AGB_FmtAlignCenter,
							 AGB_FmtAlignRight,
							 AGB_FmtAlignJustify,
							 AGB_FmtParagraphLTR,
							 AGB_FmtParagraphRTL,
							 AGB_FmtHorizontalRule,
							 AGB_FmtHyperlink,
							 AGB_FmtPicture,
							 AGB_FmtInsertEmoji,
							 AOTS_FmtInsertTable,
							 AOCS_FmtInsertSymbol };    // 27

TAdvToolBar* atb = AdvToolBar_Fmt;

// Hide all buttons
for (int i = 0; i < atb->ControlCount; i++)
	{
	atb->Controls[i]->Visible = false;
	}

// Init all button widths
	{
	for (size_t i = 0; i < std::size(BtnObj); i++)
		{
		if (BtnObj[i]->InheritsFrom(__classid(TAdvOfficeFontSelector)))
			{
			AOFNS_FmtFontName->Width = 200;
			}
		else if (BtnObj[i]->InheritsFrom(__classid(TAdvOfficeFontSizeSelector)))
			{
			AOFSS_FmtFontSize->Width = 40;
			}
		else if (BtnObj[i]->InheritsFrom(__classid(TAdvGlowButton)))
			{
			TAdvGlowButton* c = static_cast<TAdvGlowButton*>(BtnObj[i]);
			c->Width = 22;

			if (BtnObj[i] == AGB_FmtInsertEmoji)
				{
				c->Width = 22 + 16; // UNFREEZE method 2 - comment out this line to unfreeze, it doesn't like multiple widths
				}
			}
		else if (BtnObj[i]->InheritsFrom(__classid(TAdvOfficeColorSelector)))
			{
			TAdvOfficeColorSelector* c = static_cast<TAdvOfficeColorSelector*>(BtnObj[i]);
			c->Width = 22 + 16;
			}
		else if (BtnObj[i]->InheritsFrom(__classid(TAdvOfficeCharacterSelector)))
			{
			TAdvOfficeCharacterSelector* c = static_cast<TAdvOfficeCharacterSelector*>(BtnObj[i]);
			c->Width = 22;
			}
		else if (BtnObj[i]->InheritsFrom(__classid(TAdvOfficeTableSelector)))
			{
			TAdvOfficeTableSelector* c = static_cast<TAdvOfficeTableSelector*>(BtnObj[i]);
			c->Width = 22;
			}
		}
	}

// Add separators and move buttons into desired positions
	{
	// 0 = separator, 1-27 = button index
	int bc[] = { 1,2,0,3,0,4,5,6,0,7,8,0,9,10,11,0,12,13,14,15,0,16,17,18,19,0,22,23,24,0,25,0,26,27 };

	for (size_t i = 0, j = 0; i < std::size(bc); i++)
		{
		// Separator, add and move into position
		if (bc[i] == 0)
			{
			TAdvToolBarSeparator* ATBS = new TAdvToolBarSeparator(this);
								  ATBS->Visible = true;

			atb->AddToolBarControl(ATBS);
			atb->MoveToolBarControl(atb->IndexOfToolBarControl(ATBS), j++);				// UNFREEZE method 3 - comment out this line to unfreeze, it doesn't like to move control around
			}
		// Normal button, just move into position
		else
			{
			BtnObj[bc[i]-1]->Visible = true;
			atb->MoveToolBarControl(atb->IndexOfToolBarControl(BtnObj[bc[i]-1]), j++);	// UNFREEZE method 3 - comment out this line to unfreeze, it doesn't like to move control around
			}
		}
	}
}

